/* ==================================================================================
File name:      F280XBLDCPWM.H                     
Target	 : 		TMS320F280x family             
=====================================================================================*/

#ifndef __F2803X_BLDCPWM_STRUCT_H__
#define __F2803X_BLDCPWM_STRUCT_H__


/*-----------------------------------------------------------------------------
Define the structure of the PWM Driver Object 
-----------------------------------------------------------------------------*/

typedef struct {  
     	Uint16 CmtnPointer;    	// Input: Commutation (or switching) state pointer input (Q0)
     	Uint16 CmtnPointerIn;     // Input: Commutation (or switching) state pointer input (Q0)
   		int16  MfuncPeriod;     // Input: Duty ratio of the PWM outputs (Q15) 
   		Uint16 PeriodMax;    	// Parameter: Maximum period (Q0)
   		int16  DutyFunc;   	    // Input: PWM period modulation input (Q15)
   		int16  DutyFuncIn;        // Input: PWM period modulation input (Q15)
   		Uint16 PwmActive;     	// Parameter: 0 = PWM active low, 1 = PWM active high (0 or 1)
   
       } PWMGEN;

    #endif  // __F2803X_BLDCPWM_STRUCT_H__










