/* =================================================================================
File name:        RMP_CNTL.H  
===================================================================================*/


#ifndef __RMP_CNTL_H__
#define __RMP_CNTL_H__
#include "IQmathLib.h"
typedef struct { _iq    TargetValue; 	// Input: Target input (pu)
                 unsigned long RampDelayMax;	// Parameter: Maximum delay rate (Q0) - independently with global Q
		 	 	 _iq    RampLowLimit;	// Parameter: Minimum limit (pu)				  
				 _iq    RampHighLimit;	// Parameter: Maximum limit (pu)
				 unsigned long RampDelayCount; // Variable: Incremental delay (Q0) - independently with global Q
				 _iq    SetpointValue;	// Output: Target output (pu)				 
				 unsigned long EqualFlag;		// Output: Flag output (Q0) - independently with global Q
				 _iq	Tmp;			// Variable: Temp variable
		  	   } RMPCNTL;	            


/*-----------------------------------------------------------------------------
Default initalizer for the RMPCNTL object.
-----------------------------------------------------------------------------*/                     
#define RMPCNTL_DEFAULTS {  0, 		 \
                            5,		 \
                           _IQ(-1),  \
                           _IQ(1),   \
                            0,       \
                          	0,       \
                          	0,       \
                          	0,       \
                   		  }

/*------------------------------------------------------------------------------
 	RAMP Controller Macro Definition
------------------------------------------------------------------------------*/

extern void RC_MACRO(RMPCNTL *v);
#endif // __RMP_CNTL_H__
